<?php

namespace Drupal\maplibre_gl\Controller;

use Drupal\Core\Controller\ControllerBase;

/**
 * Description of MaplibreGlController.
 *
 * @author Owner
 */
class MaplibreGlController extends ControllerBase {

  /**
   * Load Maplibre maps and return a render array.
   *
   * @param string $map_name
   *   The map name to be modified.
   *
   * @return array
   *   The content array with the mandatory variables set.
   */
  public static function renderMap($map_name) {
    $map_info = maplibre_gl_map_get_info($map_name);

    $content['maplibre-container'] = [
      '#prefix' => '<div class="maplibre-gl-wrapper">',
      '#markup' => '<div id="' . $map_info['options']['container'] . '-menu" class="maplibre-gl-layer-menu"></div>'
      . '<div id="' . $map_info['options']['container'] . '" class="maplibre-gl-container"></div>',
      '#suffix' => '</div">',
    ];

    $sources = array_key_exists('sources', $map_info) ? $map_info['sources'] : [];
    $layers = array_key_exists('layers', $map_info) ? $map_info['layers'] : [];

    $settings[$map_info['options']['container']] = [
      'accessToken' => $map_info['access_token'],
      'options' => $map_info['options'],
      'sources' => $sources,
      'layers' => $layers,
      'config' => $map_info['config'],
    ];

    $content['#attached']['drupalSettings']['maplibreGl'] = $settings;
    $content['#attached']['library'][] = 'maplibre_gl/libraries.maplibre-gl-js';
    $content['#attached']['library'][] = 'maplibre_gl/maplibre_gl';

    return $content;
  }

}
